import request from 'supertest';
import { Base64 } from 'js-base64';

import { app } from '../../../../main';
import { environment } from '../../../../core/configs/environment';
import { {{Name}}InputInterface } from '../../services/repository/mongoose/models/{{inputName}}-input.interface';

const {{name}}Input: {{Name}}InputInterface = {
  email: 'user4@demo.com',
  password: '123456',
  firstName: 'user4',
  lastName: 'name4',
  age: 35,
  groups: [],
  active: true,
};
let {{name}}Id: string;

// QUERY
describe('Query GET api/v1/{{name}}s', () => {
  const _login: string | undefined = environment.info.secretLoginApiGateway;
  const _password1: string | undefined = '123456';
  const _password2: string | undefined = 'MTIzNDU2';

  it('responds with JSON array', (done) => {
    request(app.api)
      .get('/api/v1/{{name}}s/')
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(200);
        expect(res.type).toEqual('application/json');
        expect(res.body).toEqual(expect.any(Object));
        expect(res.body.data).toEqual(expect.any(Array));
        expect(res.body.data).toHaveLength(3);
        expect(res.body).not.toBeNull();
        done();
      });
  });

  it('should include first {{name}}', (done) => {
    request(app.api)
      .get('/api/v1/{{name}}s')
      .end((err, res) => {
        if (err) done(err);
        const first{{Name}} = res.body.data.find(
          ({{name}}: any) => {{name}}.firstName === 'user1',
        );
        expect(first{{Name}}).toBeTruthy();
        expect(first{{Name}}).toHaveProperty('firstName');
        expect(first{{Name}}).toHaveProperty('lastName');
        done();
      });
  });

  it('should filter only 2 {{name}}s', (done) => {
    request(app.api)
      .get('/api/v1/{{name}}s?limit=2')
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(200);
        expect(res.type).toEqual('application/json');
        expect(res.body).toEqual(expect.any(Object));
        expect(res.body.data).toEqual(expect.any(Array));
        expect(res.body.data).toHaveLength(2);
        expect(res.body).not.toBeNull();
        done();
      });
  });
});

// CREATE
describe('Create Post api/v1/{{name}}s', () => {
  const _login: string | undefined = environment.info.secretLoginApiGateway;
  const _login2: string | undefined = environment.info.secretLoginAdmin;
  const _password1: string | undefined = '123456';
  const _password2: string | undefined = 'MTIzNDU2';

  // Credential not being sent - should respond with a 401
  test('It should require authentication', (done) =>
    request(app.api)
      .post('/api/v1/{{name}}s/')
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(401);
        done();
      }));

  // Credential sent but not an admin role - should respond with a 401
  test('It should require authentication and role authorization', (done) => {
    const credentialInput = Base64.encode(`${_login}:${_password1}`);
    request(app.api)
      .post('/api/v1/{{name}}s/')
      .set({ Authorization: `Basic ${credentialInput}` })
      .send({{name}}Input)
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(401);
        done();
      });
  });

  // Credential sent with an admin role - should respond with a 201
  test('It should pass authentication and role authorization and respond with an object', (done) => {
    const credentialInput = Base64.encode(`${_login2}:${_password1}`);
    request(app.api)
      .post('/api/v1/{{name}}s/')
      .set({ Authorization: `Basic ${credentialInput}` })
      .send({{name}}Input)
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(201);
        expect(res.type).toEqual('application/json');
        expect(res.body.data).toEqual(expect.any(Object));
        expect(res.body.data).not.toBeNull();
        {{name}}Id = res.body.data._id;
        done();
      });
  });

  it('should include added {{name}}', (done) => {
    request(app.api)
      .get('/api/v1/{{name}}s')
      .end((err, res) => {
        if (err) done(err);
        const first{{Name}} = res.body.data.find(
          ({{name}}: any) => {{name}}._id === {{name}}Id,
        );
        expect(first{{Name}}).toBeTruthy();
        expect(first{{Name}}).toHaveProperty('firstName');
        expect(first{{Name}}).toHaveProperty('lastName');
        done();
      });
  });
});

// READ
describe('Read GET api/v1/{{name}}s/:id', () => {
  test('It should respond with single JSON object', (done) => {
    request(app.api)
      .get(`/api/v1/{{name}}s/${{{name}}Id}`)
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(200);
        expect(res.type).toEqual('application/json');
        expect(res.body.data).toEqual(expect.any(Object));
        expect(res.body.data).not.toBeNull();
        done();
      });
  });

  it('should return selected {{name}}', (done) => {
    request(app.api)
      .get(`/api/v1/{{name}}s/${{{name}}Id}`)
      .end((err, res) => {
        if (err) done(err);
        expect(res.body.data).toHaveProperty('firstName');
        expect(res.body.data).toHaveProperty('lastName');
        expect(res.body.data.firstName).toEqual('user4');
        done();
      });
  });
});

// UPDATE
describe('Update Put api/v1/{{name}}s:id', () => {
  const _login: string | undefined = environment.info.secretLoginApiGateway;
  const _login2: string | undefined = environment.info.secretLoginAdmin;
  const _password1: string | undefined = '123456';
  const _password2: string | undefined = 'MTIzNDU2';

  // Credential not being sent - should respond with a 401
  test('It should require authentication', (done) =>
    request(app.api)
      .put(`/api/v1/{{name}}s/${{{name}}Id}`)
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(401);
        done();
      }));

  // Credential sent but not an admin role - should respond with a 401
  test('It should require authentication and role authorization', (done) => {
    const credentialInput = Base64.encode(`${_login}:${_password1}`);
    request(app.api)
      .put(`/api/v1/{{name}}s/${{{name}}Id}`)
      .set({ Authorization: `Basic ${credentialInput}` })
      .send({ firstName: 'newName' })
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(401);
        done();
      });
  });

  // Credential sent with an admin role - should respond with a 202
  test('It should pass authentication and role authorization and respond with a  202 status', (done) => {
    const credentialInput = Base64.encode(`${_login2}:${_password1}`);
    request(app.api)
      .put(`/api/v1/{{name}}s/${{{name}}Id}`)
      .set({ Authorization: `Basic ${credentialInput}` })
      .send({ firstName: 'newName' })
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(202);
        done();
      });
  });

  it('should return updated email {{name}}', (done) => {
    request(app.api)
      .get(`/api/v1/{{name}}s/${{{name}}Id}`)
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(200);
        expect(res.type).toEqual('application/json');
        expect(res.body.data).toEqual(expect.any(Object));
        expect(res.body.data).not.toBeNull();
        expect(res.body.data).toHaveProperty('firstName');
        expect(res.body.data.firstName).toEqual('newName');
        done();
      });
  });
});

// DELETE
describe('Remove Delete api/v1/{{name}}s:id', () => {
  const _login: string | undefined = environment.info.secretLoginApiGateway;
  const _login2: string | undefined = environment.info.secretLoginAdmin;
  const _password1: string | undefined = '123456';
  const _password2: string | undefined = 'MTIzNDU2';

  // Credential not being sent - should respond with a 401
  test('It should require authentication', (done) =>
    request(app.api)
      .delete(`/api/v1/{{name}}s/${{{name}}Id}`)
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(401);
        done();
      }));

  // Credential sent but not an admin role - should respond with a 401
  test('It should require authentication and role authorization', (done) => {
    const credentialInput = Base64.encode(`${_login}:${_password1}`);
    request(app.api)
      .delete(`/api/v1/{{name}}s/${{{name}}Id}`)
      .set({ Authorization: `Basic ${credentialInput}` })
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(401);
        done();
      });
  });

  // Credential sent with an admin role - should respond with a 204
  test('It should pass authentication and role authorization and respond with a  204 status', (done) => {
    const credentialInput = Base64.encode(`${_login2}:${_password1}`);
    request(app.api)
      .delete(`/api/v1/{{name}}s/${{{name}}Id}`)
      .set({ Authorization: `Basic ${credentialInput}` })
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(204);
        done();
      });
  });

  it('should not find deleted {{name}}', (done) => {
    request(app.api)
      .get(`/api/v1/{{name}}s/${{{name}}Id}`)
      .end((err, res) => {
        if (err) done(err);
        expect(res.status).toBe(404);
        done();
      });
  });
});
